/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.payroll.dao;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.MospException;
import jp.mosp.kintai.payroll.dto.KdWorkDto;

/**
 * KD_WORK(勤怠集計)のDAOクラス 。
 */
public class KdWorkDao extends BaseDao {
	
	// テーブル名及びキー列名
	/**
	 * KD_WORK(勤怠集計)。
	 */
	public static final String	TABLE						= "KD_WORK";
	
	/**
	 * KEY_1 = K_CODE(社員コード)。
	 */
	public static final String	KEY_1						= "K_CODE";
	/**
	 * KEY_2 = SIKYU_YM(支給年月)。
	 */
	public static final String	KEY_2						= "SIKYU_YM";
	
	// 列名
	/**
	 * K_CODE(社員コード)。
	 */
	public static final String	COL_K_CODE					= "K_CODE";
	/**
	 * SIKYU_YM(支給年月)。
	 */
	public static final String	COL_SIKYU_YM				= "SIKYU_YM";
	/**
	 * S_NEN(支給年)。
	 */
	public static final String	COL_S_NEN					= "S_NEN";
	/**
	 * S_TUKI(支給月)。
	 */
	public static final String	COL_S_TUKI					= "S_TUKI";
	/**
	 * S_HI(支給日)。
	 */
	public static final String	COL_S_HI					= "S_HI";
	/**
	 * S_NISSU(出勤日数)。
	 */
	public static final String	COL_S_NISSU					= "S_NISSU";
	/**
	 * S_KAISU(出勤回数)。
	 */
	public static final String	COL_S_KAISU					= "S_KAISU";
	/**
	 * KINMU_JI(勤務時間)。
	 */
	public static final String	COL_KINMU_JI				= "KINMU_JI";
	/**
	 * KYUKEI_JI(休憩時間)。
	 */
	public static final String	COL_KYUKEI_JI				= "KYUKEI_JI";
	/**
	 * YUKYU(有給)。
	 */
	public static final String	COL_YUKYU					= "YUKYU";
	/**
	 * TOKUKYU(特別休暇)。
	 */
	public static final String	COL_TOKUKYU					= "TOKUKYU";
	/**
	 * KEKKIN(一般欠勤日数)。
	 */
	public static final String	COL_KEKKIN					= "KEKKIN";
	/**
	 * S_KEKKIN(傷病欠勤日数)。
	 */
	public static final String	COL_S_KEKKIN				= "S_KEKKIN";
	/**
	 * DAIKYU(代替休暇)。
	 */
	public static final String	COL_DAIKYU					= "DAIKYU";
	/**
	 * FURIKAE(振替休暇)。
	 */
	public static final String	COL_FURIKAE					= "FURIKAE";
	/**
	 * KK_RIYUU_6(休暇理由6)。
	 */
	public static final String	COL_KK_RIYUU_6				= "KK_RIYUU_6";
	/**
	 * KK_RIYUU_7(休暇理由7)。
	 */
	public static final String	COL_KK_RIYUU_7				= "KK_RIYUU_7";
	/**
	 * KK_RIYUU_8(休暇理由8)。
	 */
	public static final String	COL_KK_RIYUU_8				= "KK_RIYUU_8";
	/**
	 * KK_RIYUU_9(休暇理由9)。
	 */
	public static final String	COL_KK_RIYUU_9				= "KK_RIYUU_9";
	/**
	 * SONOTA(その他休暇)。
	 */
	public static final String	COL_SONOTA					= "SONOTA";
	/**
	 * TI_SO_KAI(遅刻早退回数)。
	 */
	public static final String	COL_TI_SO_KAI				= "TI_SO_KAI";
	/**
	 * TI_JIKAN(遅刻早退時間)。
	 */
	public static final String	COL_TI_SO_JIKAN				= "TI_SO_JIKAN";
	/**
	 * ZA_JIKAN(普通残業時間)。
	 */
	public static final String	COL_ZA_JIKAN				= "ZA_JIKAN";
	/**
	 * KS_JIKAN(休日出勤時間)。
	 */
	public static final String	COL_KS_JIKAN				= "KS_JIKAN";
	/**
	 * SN_JIKAN(深夜勤務時間)。
	 */
	public static final String	COL_SN_JIKAN				= "SN_JIKAN";
	/**
	 * KAIKIN(精皆勤手当支給)。
	 */
	public static final String	COL_KAIKIN					= "KAIKIN";
	/**
	 * SYOKUJI_KAISU(食事手当支給回数)。
	 */
	public static final String	COL_SYOKUJI_KAISU			= "SYOKUJI_KAISU";
	/**
	 * CYOKU_KAISU_1(1直手当支給回数)。
	 */
	public static final String	COL_CYOKU_KAISU_1			= "CYOKU_KAISU_1";
	/**
	 * CYOKU_KAISU_2(2直手当支給回数)。
	 */
	public static final String	COL_CYOKU_KAISU_2			= "CYOKU_KAISU_2";
	/**
	 * CYOKU_KAISU_3(3直手当支給回数)。
	 */
	public static final String	COL_CYOKU_KAISU_3			= "CYOKU_KAISU_3";
	/**
	 * HOKA_KAISU_1(その他支給回数1)。
	 */
	public static final String	COL_HOKA_KAISU_1			= "HOKA_KAISU_1";
	/**
	 * HOKA_KAISU_2(その他支給回数2)。
	 */
	public static final String	COL_HOKA_KAISU_2			= "HOKA_KAISU_2";
	/**
	 * HOKA_KAISU_3(その他支給回数3)。
	 */
	public static final String	COL_HOKA_KAISU_3			= "HOKA_KAISU_3";
	/**
	 * HOKA_KAISU_4(その他支給回数4)。
	 */
	public static final String	COL_HOKA_KAISU_4			= "HOKA_KAISU_4";
	/**
	 * HOKA_KAISU_5(その他支給回数5)。
	 */
	public static final String	COL_HOKA_KAISU_5			= "HOKA_KAISU_5";
	/**
	 * SINSEI_GAKU(支払申請額)。
	 */
	public static final String	COL_SINSEI_GAKU				= "SINSEI_GAKU";
	/**
	 * WARIMASI_1(1.00割増)。
	 */
	public static final String	COL_WARIMASI_1				= "WARIMASI_1";
	/**
	 * WEEK_DAY_OVER_TIME(平日時間外)。
	 */
	public static final String	COL_WEEK_DAY_OVER_TIME		= "WEEK_DAY_OVER_TIME";
	/**
	 * WEEK_HOLIDAY_OVER_TIME(所定休日時間外)。
	 */
	public static final String	COL_WEEK_HOLIDAY_OVER_TIME	= "WEEK_HOLIDAY_OVER_TIME";
	/**
	 * MONTHLY_OVER_TIME(月60時間超過平日時間外)。
	 */
	public static final String	COL_MONTHLY_OVER_TIME		= "MONTHLY_OVER_TIME";
	/**
	 * MONTHLY_WEEK_HOLIDAY(月60時間超過所定休日時間外)。
	 */
	public static final String	COL_MONTHLY_WEEK_HOLIDAY	= "MONTHLY_WEEK_HOLIDAY";
	/**
	 * HOUR_HOLIDAY(時間単位年休取得時間)。
	 */
	public static final String	COL_HOUR_HOLIDAY			= "HOUR_HOLIDAY";
	/**
	 * SUBSTITUTE_HOLIDAY(時間外時間代替休暇取得日数)。
	 */
	public static final String	COL_SUBSTITUTE_HOLIDAY		= "SUBSTITUTE_HOLIDAY";
	/**
	 * AMEND_FLAG(修正フラグ)。
	 */
	public static final String	COL_AMEND_FLAG				= "AMEND_FLAG";
	

	/**
	 * コンストラクタ。
	 */
	public KdWorkDao() {
		super();
		INSERT_DATE = "INSERT_DATE";
		INSERT_USER = "INSERT_USER";
		UPDATE_DATE = "UPDATE_DATE";
		UPDATE_USER = "UPDATE_USER";
	}
	
	/**
	 * 検索結果取得(DTOのList)。
	 * @return 検索結果リスト
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private List<KdWorkDto> mappingAll() throws SQLException {
		List<KdWorkDto> all = new ArrayList<KdWorkDto>();
		while (rs.next()) {
			all.add(mapping());
		}
		return all;
	}
	
	/**
	 * 検索結果取得(DTO)。
	 * @return KD_WORKレコード
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private KdWorkDto mapping() throws SQLException {
		KdWorkDto dto = new KdWorkDto();
		dto.setKCode(rs.getString(COL_K_CODE));
		dto.setSikyuYm(rs.getString(COL_SIKYU_YM));
		dto.setSNen(rs.getInt(COL_S_NEN));
		dto.setSTuki(rs.getInt(COL_S_TUKI));
		dto.setSHi(rs.getInt(COL_S_HI));
		dto.setSNissu(rs.getDouble(COL_S_NISSU));
		dto.setSKaisu(rs.getInt(COL_S_KAISU));
		dto.setKinmuJi(rs.getInt(COL_KINMU_JI));
		dto.setKyukeiJi(rs.getInt(COL_KYUKEI_JI));
		dto.setYukyu(rs.getDouble(COL_YUKYU));
		dto.setTokukyu(rs.getDouble(COL_TOKUKYU));
		dto.setKekkin(rs.getDouble(COL_KEKKIN));
		dto.setSKekkin(rs.getDouble(COL_S_KEKKIN));
		dto.setDaikyu(rs.getDouble(COL_DAIKYU));
		dto.setFurikae(rs.getDouble(COL_FURIKAE));
		dto.setKkRiyuu6(rs.getDouble(COL_KK_RIYUU_6));
		dto.setKkRiyuu7(rs.getDouble(COL_KK_RIYUU_7));
		dto.setKkRiyuu8(rs.getDouble(COL_KK_RIYUU_8));
		dto.setKkRiyuu9(rs.getDouble(COL_KK_RIYUU_9));
		dto.setSonota(rs.getDouble(COL_SONOTA));
		dto.setTiSoKai(rs.getInt(COL_TI_SO_KAI));
		dto.setTiSoJikan(rs.getInt(COL_TI_SO_JIKAN));
		dto.setZaJikan(rs.getInt(COL_ZA_JIKAN));
		dto.setKsJikan(rs.getInt(COL_KS_JIKAN));
		dto.setSnJikan(rs.getInt(COL_SN_JIKAN));
		dto.setKaikin(rs.getInt(COL_KAIKIN));
		dto.setSyokujiKaisu(rs.getInt(COL_SYOKUJI_KAISU));
		dto.setCyokuKaisu1(rs.getInt(COL_CYOKU_KAISU_1));
		dto.setCyokuKaisu2(rs.getInt(COL_CYOKU_KAISU_2));
		dto.setCyokuKaisu3(rs.getInt(COL_CYOKU_KAISU_3));
		dto.setHokaKaisu1(rs.getInt(COL_HOKA_KAISU_1));
		dto.setHokaKaisu2(rs.getInt(COL_HOKA_KAISU_2));
		dto.setHokaKaisu3(rs.getInt(COL_HOKA_KAISU_3));
		dto.setHokaKaisu4(rs.getInt(COL_HOKA_KAISU_4));
		dto.setHokaKaisu5(rs.getInt(COL_HOKA_KAISU_5));
		dto.setSinseiGaku(rs.getInt(COL_SINSEI_GAKU));
		dto.setWarimasi1(rs.getInt(COL_WARIMASI_1));
		dto.setWeekDayOverTime(rs.getInt(COL_WEEK_DAY_OVER_TIME));
		dto.setWeekHolidayOverTime(rs.getInt(COL_WEEK_HOLIDAY_OVER_TIME));
		dto.setMonthlyOverTime(rs.getInt(COL_MONTHLY_OVER_TIME));
		dto.setMonthlyWeekHoliday(rs.getInt(COL_MONTHLY_WEEK_HOLIDAY));
		dto.setHourHoliday(rs.getInt(COL_HOUR_HOLIDAY));
		dto.setSubstituteHoliday(rs.getDouble(COL_SUBSTITUTE_HOLIDAY));
		dto.setAmendFlag(rs.getInt(COL_AMEND_FLAG));
		mappingCommonInfo(dto);
		return dto;
	}
	
	/**
	 * 全データ取得。
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<KdWorkDto> findAll() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			prepareStatement(getSelectQuery(getClass()) + getOrderForKey(getClass()));
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得
	 * @param kCode 社員コード(検索キー)
	 * @param sikyuYm 支給年月(検索キー)
	 * @return KdWorkDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public KdWorkDto findForKey(String kCode, String sikyuYm) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, kCode);
			setParam(index++, sikyuYm);
			executeQuery();
			KdWorkDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得
	 * @param kCode 社員コード(検索キー)
	 * @param sikyuYm 支給年月(検索キー)
	 * @return KdWorkDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public KdWorkDto findForUpdate(String kCode, String sikyuYm) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, kCode);
			setParam(index++, sikyuYm);
			executeQuery();
			KdWorkDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得
	 * @param sikyuYm 支給年月(検索キー)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public void findForUpdate(String sikyuYm) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_SIKYU_YM);
			sb.append(" = ? ");
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getForUpdate());
			setParam(index++, sikyuYm);
			executeQuery();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param kCode 検索社員コード
	 * @param sikyuYm 検索支給年月
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<?> findForCondition(String kCode, String sikyuYm) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(COL_K_CODE);
		sb.append(" LIKE ? AND ");
		sb.append(COL_SIKYU_YM);
		sb.append(" LIKE ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, kCode);
			setParam(index++, sikyuYm + "%");
			executeQuery();
			List<?> list = mappingAll();
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param sikyuYm 支給年月
	 * @return 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<KdWorkDto> findForCondition(String sikyuYm) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(COL_SIKYU_YM);
		sb.append(" = ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, sikyuYm);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得(範囲指定)
	 * @param kCode 検索社員コード
	 * @param startSikyuNen 検索開始年
	 * @param startSikyuTuki 検索終了年
	 * @param endSikyuNen 検索開始月
	 * @param endSikyuTuki 検索終了月
	 * @param dif 差分年
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<KdWorkDto> findForCondition(String kCode, int startSikyuNen, int startSikyuTuki, int endSikyuNen,
			int endSikyuTuki, int dif) throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(COL_K_CODE);
		sb.append(" = ? AND ");
		if (dif != 0) {
			sb.append("((");
			sb.append(COL_S_NEN);
			sb.append(" = ? AND ");
			sb.append(COL_S_TUKI);
			sb.append(" BETWEEN");
			sb.append(" ? AND ? )");
			sb.append(" OR ");
		}
		for (int i = 1; dif > i; i++) {
			sb.append(COL_S_NEN);
			sb.append(" = ?");
			sb.append(" OR ");
		}
		sb.append("(");
		sb.append(COL_S_NEN);
		sb.append(" = ? AND ");
		sb.append(COL_S_TUKI);
		sb.append(" BETWEEN");
		sb.append(" ? AND ? )");
		if (dif != 0) {
			sb.append(")");
		}
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, kCode);
			if (dif != 0) {
				setParam(index++, startSikyuNen);
				setParam(index++, startSikyuTuki);
				setParam(index++, 12);
			}
			for (int i = 1; dif > i; i++) {
				setParam(index++, startSikyuNen + i);
			}
			setParam(index++, endSikyuNen);
			if (dif == 0) {
				setParam(index++, startSikyuTuki);
			} else {
				setParam(index++, 1);
			}
			setParam(index++, endSikyuTuki);
			executeQuery();
			List<KdWorkDto> list = mappingAll();
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param sikyuYm 検索支給年月
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<KdWorkDto> findForExport(String sikyuYm) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(COL_SIKYU_YM);
		sb.append(" = ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, sikyuYm);
			executeQuery();
			List<KdWorkDto> list = mappingAll();
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入
	 * @param dto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public int insert(KdWorkDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException, MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass()));
			setParams(dto, true);
			executeUpdate();
			chkInsert(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * @param list		新勤怠情報
	 * @param divSize	件数
	 * @return	挿入結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int insert(List<KdWorkDto> list, int divSize) throws SQLException, IllegalAccessException,
			NoSuchFieldException, MospException {
		try {
			index = 1;
			int listSize = list.size();
			int rev = listSize / divSize + 1;
			if (listSize % divSize == 0) {
				rev--;
			}
			int insertCount = 0;
			List<KdWorkDto> divList = new ArrayList<KdWorkDto>();
			for (int i = 0; i < rev; i++) {
				// リストをdiv件ごと分割する。
				for (int k = 0; k < divSize; k++) {
					int count = k + (i * divSize);
					if (count >= listSize) {
						break;
					}
					divList.add(list.get(count));
				}
				int divListSize = divList.size();
				prepareStatement(getInsertQuery(getClass(), divListSize, divSize));
				for (KdWorkDto dto : divList) {
					setParams(dto, true);
				}
				executeUpdate();
				clearParams();
				index = 1;
				divList.clear();
				chkInsert(divListSize);
				insertCount += cnt;
			}
			return insertCount;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入
	 * @param 	aryDto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public int insert(KdWorkDto[] aryDto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass(), aryDto.length, aryDto.length));
			for (KdWorkDto dto : aryDto) {
				setParams(dto, true);
			}
			executeUpdate();
			chkInsert(aryDto.length);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ更新
	 * @param dto 更新対象DTO
	 * @return int 更新結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public int update(KdWorkDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException, MospException {
		try {
			index = 1;
			prepareStatement(getUpdateQuery(getClass()));
			setParams(dto, false);
			setParam(index++, dto.getKCode());
			setParam(index++, dto.getSikyuYm());
			executeUpdate();
			chkUpdate(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除
	 * @param dto 更新対象DTO
	 * @return int 削除結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public int delete(KdWorkDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException, MospException {
		try {
			index = 1;
			prepareStatement(getDeleteQuery(getClass()));
			setParam(index++, dto.getKCode());
			setParam(index++, dto.getSikyuYm());
			executeUpdate();
			chkDelete(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除
	 * @param aryDto 更新対象DTO
	 * @param sikyuYm 検索支給年月
	 * @return int 削除結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public int delete(KdWorkDto[] aryDto, String sikyuYm) throws SQLException, IllegalAccessException,
			NoSuchFieldException, MospException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("DELETE FROM ");
			sb.append(TABLE);
			sb.append(" WHERE (");
			int i = 0;
			while (i != aryDto.length) {
				sb.append(COL_K_CODE);
				sb.append(" = ? OR ");
				i++;
			}
			sb.delete(sb.length() - 4, sb.length());
			sb.append(") AND ");
			sb.append(COL_SIKYU_YM);
			sb.append(" = ?");
			prepareStatement(sb.toString());
			for (KdWorkDto dto : aryDto) {
				setParam(index++, dto.getKCode());
			}
			setParam(index++, sikyuYm);
			executeUpdate();
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除
	 * @param 	sikyuYm	更新対象年月
	 * @return int 削除結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public int delete(String sikyuYm) throws SQLException, IllegalAccessException, NoSuchFieldException, MospException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("DELETE FROM ");
			sb.append(TABLE);
			sb.append(" ");
			sb.append("WHERE ");
			sb.append(COL_SIKYU_YM);
			sb.append(" = ? ");
			prepareStatement(sb.toString());
			setParam(index++, sikyuYm);
			executeUpdate();
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * パラメータ設定。
	 * @param dto 更新対象DTO
	 * @param isInsert 挿入文フラグ(true：挿入文、false：挿入文)
	 * @throws SQLException SQL例外が発生した場合
	 */
	private void setParams(KdWorkDto dto, boolean isInsert) throws SQLException {
		setParam(index++, dto.getKCode());
		setParam(index++, dto.getSikyuYm());
		setParam(index++, dto.getSNen());
		setParam(index++, dto.getSTuki());
		setParam(index++, dto.getSHi());
		setParam(index++, dto.getSNissu());
		setParam(index++, dto.getSKaisu());
		setParam(index++, dto.getKinmuJi());
		setParam(index++, dto.getKyukeiJi());
		setParam(index++, dto.getYukyu());
		setParam(index++, dto.getTokukyu());
		setParam(index++, dto.getKekkin());
		setParam(index++, dto.getSKekkin());
		setParam(index++, dto.getDaikyu());
		setParam(index++, dto.getFurikae());
		setParam(index++, dto.getKkRiyuu6());
		setParam(index++, dto.getKkRiyuu7());
		setParam(index++, dto.getKkRiyuu8());
		setParam(index++, dto.getKkRiyuu9());
		setParam(index++, dto.getSonota());
		setParam(index++, dto.getTiSoKai());
		setParam(index++, dto.getTiSoJikan());
		setParam(index++, dto.getZaJikan());
		setParam(index++, dto.getKsJikan());
		setParam(index++, dto.getSnJikan());
		setParam(index++, dto.getKaikin());
		setParam(index++, dto.getSyokujiKaisu());
		setParam(index++, dto.getCyokuKaisu1());
		setParam(index++, dto.getCyokuKaisu2());
		setParam(index++, dto.getCyokuKaisu3());
		setParam(index++, dto.getHokaKaisu1());
		setParam(index++, dto.getHokaKaisu2());
		setParam(index++, dto.getHokaKaisu3());
		setParam(index++, dto.getHokaKaisu4());
		setParam(index++, dto.getHokaKaisu5());
		setParam(index++, dto.getSinseiGaku());
		setParam(index++, dto.getWarimasi1());
		setParam(index++, dto.getWeekDayOverTime());
		setParam(index++, dto.getWeekHolidayOverTime());
		setParam(index++, dto.getMonthlyOverTime());
		setParam(index++, dto.getMonthlyWeekHoliday());
		setParam(index++, dto.getHourHoliday());
		setParam(index++, dto.getSubstituteHoliday());
		setParam(index++, dto.getAmendFlag());
		setCommonParams(isInsert);
	}
	
	/**
	 * テーブルロック
	 * @param 	sikyuYm	更新対象年月
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public void tableLock(String sikyuYm) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			if (conn.getMetaData().getDatabaseProductName().equals("MySQL")) {
				// DBがMySQLの場合は行ロック
				findForUpdate(sikyuYm);
			} else {
				// DBがPostgreSQLの場合はテーブルロック
				StringBuffer sb = new StringBuffer();
				sb.append("LOCK TABLE ");
				sb.append(TABLE);
				prepareStatement(sb.toString());
				executeUpdate();
			}
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * テーブルロック
	 * @param	kCode 社員コード
	 * @param 	sikyuYm	更新対象年月
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public void tableLock(String kCode, String sikyuYm) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			if (conn.getMetaData().getDatabaseProductName().equals("MySQL")) {
				// DBがMySQLの場合は行ロック
				findForUpdate(kCode, sikyuYm);
			} else {
				// DBがPostgreSQLの場合はテーブルロック
				StringBuffer sb = new StringBuffer();
				sb.append("LOCK TABLE ");
				sb.append(TABLE);
				prepareStatement(sb.toString());
				executeUpdate();
			}
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * テーブルロック
	 * @param listKdWork DTO
	 * @param sikyuYm 更新対象年月
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public void tableLock(List<KdWorkDto> listKdWork, String sikyuYm) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			if (conn.getMetaData().getDatabaseProductName().equals("MySQL")) {
				// DBがMySQLの場合は行ロック
				for (KdWorkDto kdWork : listKdWork) {
					KdWorkDto dto = kdWork;
					findForUpdate(dto.getKCode(), sikyuYm);
				}
			} else {
				// DBがPostgreSQLの場合はテーブルロック
				StringBuffer sb = new StringBuffer();
				sb.append("LOCK TABLE ");
				sb.append(TABLE);
				prepareStatement(sb.toString());
				executeUpdate();
			}
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
}
